diff --git a/arch/arm/dts/uniphier-ld20.dtsi b/arch/arm/dts/uniphier-ld20.dtsi
index 21a431ab7f..9155b39dfa 100644
--- a/arch/arm/dts/uniphier-ld20.dtsi
+++ b/arch/arm/dts/uniphier-ld20.dtsi
@@ -744,7 +744,7 @@
 			};
 		};
 
-		_usb: usb@65a00000 {
+		usb: usb@65a00000 {
 			compatible = "socionext,uniphier-dwc3", "snps,dwc3";
 			status = "disabled";
 			reg = <0x65a00000 0xcd00>;
@@ -895,25 +895,6 @@
 			};
 		};
 
-		/* FIXME: U-Boot own node */
-		usb: usb@65b00000 {
-			compatible = "socionext,uniphier-ld20-dwc3";
-			reg = <0x65b00000 0x1000>;
-			#address-cells = <1>;
-			#size-cells = <1>;
-			ranges;
-			pinctrl-names = "default";
-			pinctrl-0 = <&pinctrl_usb0>, <&pinctrl_usb1>,
-				    <&pinctrl_usb2>, <&pinctrl_usb3>;
-			dwc3@65a00000 {
-				compatible = "snps,dwc3";
-				reg = <0x65a00000 0x10000>;
-				interrupts = <0 134 4>;
-				dr_mode = "host";
-				tx-fifo-resize;
-			};
-		};
-
 		pcie: pcie@66000000 {
 			compatible = "socionext,uniphier-pcie", "snps,dw-pcie";
 			status = "disabled";
diff --git a/arch/arm/dts/uniphier-pro4.dtsi b/arch/arm/dts/uniphier-pro4.dtsi
index 0e0a30ab40..3412c800e3 100644
--- a/arch/arm/dts/uniphier-pro4.dtsi
+++ b/arch/arm/dts/uniphier-pro4.dtsi
@@ -503,7 +503,7 @@
 			};
 		};
 
-		_usb0: usb@65a00000 {
+		usb0: usb@65a00000 {
 			compatible = "socionext,uniphier-dwc3", "snps,dwc3";
 			status = "disabled";
 			reg = <0x65a00000 0xcd00>;
@@ -557,26 +557,7 @@
 			};
 		};
 
-		/* FIXME: U-Boot own node */
-		usb0: usb@65b00000 {
-			compatible = "socionext,uniphier-pro4-dwc3";
-			status = "disabled";
-			reg = <0x65b00000 0x1000>;
-			#address-cells = <1>;
-			#size-cells = <1>;
-			ranges;
-			pinctrl-names = "default";
-			pinctrl-0 = <&pinctrl_usb0>;
-			dwc3@65a00000 {
-				compatible = "snps,dwc3";
-				reg = <0x65a00000 0x10000>;
-				interrupts = <0 134 4>;
-				dr_mode = "host";
-				tx-fifo-resize;
-			};
-		};
-
-		_usb1: usb@65c00000 {
+		usb1: usb@65c00000 {
 			compatible = "socionext,uniphier-dwc3", "snps,dwc3";
 			status = "disabled";
 			reg = <0x65c00000 0xcd00>;
@@ -618,25 +599,6 @@
 			};
 		};
 
-		/* FIXME: U-Boot own node */
-		usb1: usb@65d00000 {
-			compatible = "socionext,uniphier-pro4-dwc3";
-			status = "disabled";
-			reg = <0x65d00000 0x1000>;
-			#address-cells = <1>;
-			#size-cells = <1>;
-			ranges;
-			pinctrl-names = "default";
-			pinctrl-0 = <&pinctrl_usb1>;
-			dwc3@65c00000 {
-				compatible = "snps,dwc3";
-				reg = <0x65c00000 0x10000>;
-				interrupts = <0 137 4>;
-				dr_mode = "host";
-				tx-fifo-resize;
-			};
-		};
-
 		nand: nand-controller@68000000 {
 			compatible = "socionext,uniphier-denali-nand-v5a";
 			status = "disabled";
diff --git a/arch/arm/dts/uniphier-pxs2.dtsi b/arch/arm/dts/uniphier-pxs2.dtsi
index cafa14e22e..da855e3f71 100644
--- a/arch/arm/dts/uniphier-pxs2.dtsi
+++ b/arch/arm/dts/uniphier-pxs2.dtsi
@@ -593,7 +593,7 @@
 			};
 		};
 
-		_usb0: usb@65a00000 {
+		usb0: usb@65a00000 {
 			compatible = "socionext,uniphier-dwc3", "snps,dwc3";
 			status = "disabled";
 			reg = <0x65a00000 0xcd00>;
@@ -690,26 +690,7 @@
 			};
 		};
 
-		/* FIXME: U-Boot own node */
-		usb0: usb@65b00000 {
-			compatible = "socionext,uniphier-pxs2-dwc3";
-			status = "disabled";
-			reg = <0x65b00000 0x1000>;
-			#address-cells = <1>;
-			#size-cells = <1>;
-			ranges;
-			pinctrl-names = "default";
-			pinctrl-0 = <&pinctrl_usb0>, <&pinctrl_usb2>;
-			dwc3@65a00000 {
-				compatible = "snps,dwc3";
-				reg = <0x65a00000 0x10000>;
-				interrupts = <0 134 4>;
-				dr_mode = "host";
-				tx-fifo-resize;
-			};
-		};
-
-		_usb1: usb@65c00000 {
+		usb1: usb@65c00000 {
 			compatible = "socionext,uniphier-dwc3", "snps,dwc3";
 			status = "disabled";
 			reg = <0x65c00000 0xcd00>;
@@ -794,25 +775,6 @@
 			};
 		};
 
-		/* FIXME: U-Boot own node */
-		usb1: usb@65d00000 {
-			compatible = "socionext,uniphier-pxs2-dwc3";
-			status = "disabled";
-			reg = <0x65d00000 0x1000>;
-			#address-cells = <1>;
-			#size-cells = <1>;
-			ranges;
-			pinctrl-names = "default";
-			pinctrl-0 = <&pinctrl_usb1>, <&pinctrl_usb3>;
-			dwc3@65c00000 {
-				compatible = "snps,dwc3";
-				reg = <0x65c00000 0x10000>;
-				interrupts = <0 137 4>;
-				dr_mode = "host";
-				tx-fifo-resize;
-			};
-		};
-
 		nand: nand-controller@68000000 {
 			compatible = "socionext,uniphier-denali-nand-v5b";
 			status = "disabled";
diff --git a/arch/arm/dts/uniphier-pxs3.dtsi b/arch/arm/dts/uniphier-pxs3.dtsi
index 1b0f49e00d..059a66b782 100644
--- a/arch/arm/dts/uniphier-pxs3.dtsi
+++ b/arch/arm/dts/uniphier-pxs3.dtsi
@@ -595,7 +595,7 @@
 			};
 		};
 
-		_usb0: usb@65a00000 {
+		usb0: usb@65a00000 {
 			compatible = "socionext,uniphier-dwc3", "snps,dwc3";
 			status = "disabled";
 			reg = <0x65a00000 0xcd00>;
@@ -698,26 +698,7 @@
 			};
 		};
 
-		/* FIXME: U-Boot own node */
-		usb0: usb@65b00000 {
-			compatible = "socionext,uniphier-pxs3-dwc3";
-			status = "disabled";
-			reg = <0x65b00000 0x1000>;
-			#address-cells = <1>;
-			#size-cells = <1>;
-			ranges;
-			pinctrl-names = "default";
-			pinctrl-0 = <&pinctrl_usb0>, <&pinctrl_usb2>;
-			dwc3@65a00000 {
-				compatible = "snps,dwc3";
-				reg = <0x65a00000 0x10000>;
-				interrupts = <0 134 4>;
-				dr_mode = "host";
-				tx-fifo-resize;
-			};
-		};
-
-		_usb1: usb@65c00000 {
+		usb1: usb@65c00000 {
 			compatible = "socionext,uniphier-dwc3", "snps,dwc3";
 			status = "disabled";
 			reg = <0x65c00000 0xcd00>;
@@ -812,25 +793,6 @@
 			};
 		};
 
-		/* FIXME: U-Boot own node */
-		usb1: usb@65d00000 {
-			compatible = "socionext,uniphier-pxs3-dwc3";
-			status = "disabled";
-			reg = <0x65d00000 0x1000>;
-			#address-cells = <1>;
-			#size-cells = <1>;
-			ranges;
-			pinctrl-names = "default";
-			pinctrl-0 = <&pinctrl_usb1>, <&pinctrl_usb3>;
-			dwc3@65c00000 {
-				compatible = "snps,dwc3";
-				reg = <0x65c00000 0x10000>;
-				interrupts = <0 137 4>;
-				dr_mode = "host";
-				tx-fifo-resize;
-			};
-		};
-
 		pcie: pcie@66000000 {
 			compatible = "socionext,uniphier-pcie", "snps,dw-pcie";
 			status = "disabled";